/*
 * Semantic Similarity API
 *
 * This API computes the simlarity of RDF entities
 *
 * The version of the OpenAPI document: 0.0.1
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.SemanticSimilarity.Core.Client.OpenAPIDateConverter;

namespace Coscine.SemanticSimilarity.Core.Model
{
    /// <summary>
    /// SimilarityOutput
    /// </summary>
    [DataContract(Name = "SimilarityOutput")]
    public partial class SimilarityOutput : IEquatable<SimilarityOutput>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SimilarityOutput" /> class.
        /// </summary>
        /// <param name="method">method.</param>
        /// <param name="returnObject">returnObject.</param>
        public SimilarityOutput(string method = default(string), SimilarityReturnOutput returnObject = default(SimilarityReturnOutput))
        {
            this.Method = method;
            this.ReturnObject = returnObject;
        }

        /// <summary>
        /// Gets or Sets Method
        /// </summary>
        [DataMember(Name = "method", EmitDefaultValue = false)]
        public string Method { get; set; }

        /// <summary>
        /// Gets or Sets ReturnObject
        /// </summary>
        [DataMember(Name = "returnObject", EmitDefaultValue = false)]
        public SimilarityReturnOutput ReturnObject { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class SimilarityOutput {\n");
            sb.Append("  Method: ").Append(Method).Append("\n");
            sb.Append("  ReturnObject: ").Append(ReturnObject).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as SimilarityOutput);
        }

        /// <summary>
        /// Returns true if SimilarityOutput instances are equal
        /// </summary>
        /// <param name="input">Instance of SimilarityOutput to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SimilarityOutput input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Method == input.Method ||
                    (this.Method != null &&
                    this.Method.Equals(input.Method))
                ) && 
                (
                    this.ReturnObject == input.ReturnObject ||
                    (this.ReturnObject != null &&
                    this.ReturnObject.Equals(input.ReturnObject))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Method != null)
                {
                    hashCode = (hashCode * 59) + this.Method.GetHashCode();
                }
                if (this.ReturnObject != null)
                {
                    hashCode = (hashCode * 59) + this.ReturnObject.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
